#include <cstring>
#include <iostream>
#include <math.h>
#include <vector>
#include <assert.h>
#include <tr1/unordered_map>
using namespace std;
typedef struct {
  unsigned __modelVars_ : 3;
} StateProp;

extern "C"
StateProp *newStateProp() {
  StateProp *stateProp = new StateProp();
  unsigned numInts = sizeof(StateProp) / sizeof(unsigned);
  unsigned *array = (unsigned *)(stateProp);
  array[numInts-1] = 0;
  return stateProp;
}

unsigned numSuccStates = 0;
unsigned succStatesList[5];
unsigned succRatesList[5];
unsigned numActiveCommands;
StateProp *succProp = newStateProp();
struct eqstate {
  bool operator()(const StateProp* s1, const StateProp* s2) const {
    unsigned numInts = sizeof(StateProp) / sizeof(unsigned);
    unsigned *array1 = (unsigned *)(s1);
    unsigned *array2 = (unsigned *)(s2);
    for (unsigned i = 0; i < numInts; i++) {
      if (array1[i] != array2[i]) {
        return false;
      }
    }
    return true;
  }
};

struct hashstate {
  size_t operator()(const StateProp* s) const {
    unsigned numInts = sizeof(StateProp) / sizeof(unsigned);
    unsigned *array = (unsigned *)(s);
    size_t hash = 0;

    for (unsigned i = 0; i < numInts; i++) {
      hash = array[i] + (hash << 6) + (hash << 16) - hash;
    }
    return hash;
  }
};

std::tr1::unordered_map<const StateProp*, unsigned, hashstate,eqstate> stateMap;
vector<StateProp *> stateList;
vector<unsigned> initialStates;
extern "C"
void getStateSuccessors(unsigned state) {
  numSuccStates = 0;
  numActiveCommands = 0;
  StateProp *stateProp = stateList[state];
  int __modelVars_ = stateProp->__modelVars_;
  __modelVars_ += -2;
  int __modelVars_P;
  unsigned succNr;
  if ((__modelVars_) == (0.0)) {
    numActiveCommands++;
    unsigned rate__;
    rate__ = 0;
    __modelVars_P = -1.0;
    succProp->__modelVars_ = unsigned(__modelVars_P - -2);
if (0 != stateMap.count(succProp)) {
      succNr = stateMap[succProp];
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    } else {
      stateList.push_back(succProp);
      succNr = stateList.size() - 1;
      stateMap[succProp] = succNr;
      succProp = newStateProp();
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    }
    rate__ = 1;
    __modelVars_P = 1.0;
    succProp->__modelVars_ = unsigned(__modelVars_P - -2);
if (0 != stateMap.count(succProp)) {
      succNr = stateMap[succProp];
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    } else {
      stateList.push_back(succProp);
      succNr = stateList.size() - 1;
      stateMap[succProp] = succNr;
      succProp = newStateProp();
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    }
  }
  if (((0.0) <= ((-1.0) + (__modelVars_))) && ((0.0) <= ((3.0) + ((-1.0) * (__modelVars_))))) {
    numActiveCommands++;
    unsigned rate__;
    rate__ = 2;
    __modelVars_P = 0.0;
    succProp->__modelVars_ = unsigned(__modelVars_P - -2);
if (0 != stateMap.count(succProp)) {
      succNr = stateMap[succProp];
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    } else {
      stateList.push_back(succProp);
      succNr = stateList.size() - 1;
      stateMap[succProp] = succNr;
      succProp = newStateProp();
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    }
    rate__ = 3;
    __modelVars_P = (1.0) + (__modelVars_);
    succProp->__modelVars_ = unsigned(__modelVars_P - -2);
if (0 != stateMap.count(succProp)) {
      succNr = stateMap[succProp];
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    } else {
      stateList.push_back(succProp);
      succNr = stateList.size() - 1;
      stateMap[succProp] = succNr;
      succProp = newStateProp();
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    }
  }
  if (((-1.0) + ((-1.0) * (__modelVars_))) == (0.0)) {
    numActiveCommands++;
    unsigned rate__;
    rate__ = 4;
    __modelVars_P = -2.0;
    succProp->__modelVars_ = unsigned(__modelVars_P - -2);
if (0 != stateMap.count(succProp)) {
      succNr = stateMap[succProp];
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    } else {
      stateList.push_back(succProp);
      succNr = stateList.size() - 1;
      stateMap[succProp] = succNr;
      succProp = newStateProp();
      succStatesList[numSuccStates] = succNr;
      succRatesList[numSuccStates] = rate__;
    numSuccStates++;
    }
  }
}
extern "C"
void addInitialStates() {
  StateProp *stateProp;
  stateProp = newStateProp();
  stateProp->__modelVars_ = 0.0 - -2;
  stateList.push_back(stateProp);
  stateMap[stateProp] = stateList.size() - 1;
  initialStates.push_back(stateList.size() - 1);
}

extern "C"
unsigned *getNumSuccStates() {
  return &numSuccStates;
}

extern "C"
unsigned *getNumActiveCommands() {
  return &numActiveCommands;
}

extern "C"
unsigned *getSuccStatesList() {
  return succStatesList;
}

extern "C"
unsigned *getSuccRatesList() {
  return succRatesList;
}

extern "C"
unsigned getNumStates() {
  return stateList.size();
}

extern "C"
vector<unsigned> *getInitialStates() {
  return &initialStates;
}

extern "C"
bool inStateSet(unsigned setNr, unsigned state) {
  StateProp *stateProp = stateList[state];
  int __modelVars_ = stateProp->__modelVars_;
  __modelVars_ += -2;
  if ((setNr == 0) && (false)) {
    return true;
  }
  if ((setNr == 1) && (((4.0) + ((-1.0) * (__modelVars_))) == (0.0))) {
    return true;
  }
  return false;
}

extern "C"
void cleanup() {
  delete succProp;
  for (unsigned state = 0; state < stateList.size(); state++) {
    delete stateList[state];
  }
}

extern "C"
double getReward(unsigned state) {
  StateProp *stateProp = stateList[state];
  int __modelVars_ = stateProp->__modelVars_;
  __modelVars_ += -2;
  double reward = 0.0;
  return reward;
}

extern "C"
unsigned getRationalReward(unsigned state) {
  StateProp *stateProp = stateList[state];
  int __modelVars_ = stateProp->__modelVars_;
  __modelVars_ += -2;
  unsigned reward = 0;
  return reward;
}

extern "C"
int getValue(unsigned state, const std::string &variable) {
  StateProp *stateProp = stateList[state];
  if (variable == "__modelVars_") {
    int result = stateProp->__modelVars_;
    result += -2;
    return result;
  }
  assert(false);
  }

extern "C"
vector<void *> *getStateList() {
  return (vector<void *> *) &stateList;
}


