# ===============================================================
#  == Zeroconf (IPOPT)                                          ==
#  ==                                                           ==
#  ==   Supplement of the work:                                 ==
#  ==                                                           ==
#  ==     Model Repair for probabilistic systems                ==
#  ==     E. Bartocci, R. Grosu, P. Katsaros,                   ==
#  ==     C.R. Ramakrishnan, Scott A. Smolka, TACAS 2011        ==
#  ==                                                           ==
#  ==   Authors of this file:                                   ==
#  ==                                                           ==
#  ==     E. Bartocci, P. Katsaros                              ==
#  ==                                                           ==
#  ==   Date:  07/07/10                                         ==
#  ==   Free distribution with authors permission               ==
#  ==                                                           ==
#  ==   SUNY Stony Brook, Stony Brook, NY                       ==
#  ==   Aristotle University of Thessaloniki, Greece            ==
#  ==                                                           ==
#  ===============================================================
##############################################################################

# Definition of the variables with bounds
var q, >= 0, <= 1;

# objective function
minimize obj:
  -((890*q -3000) / (999*q -1000)) + q^2;

# and the constraints
subject to c1:
  (-q / (999*q -1000)) < 0.001;


# Now we set the starting point:

let q := 0;

